src/oscar/apps/search/forms.py
from collections import defaultdict

from django import forms
from django.conf import settings
from django.forms.widgets import Input
from django.utils.translation import gettext_lazy as _

from haystack.forms import FacetedSearchForm

from oscar.core.loading import get_class

is_solr_supported = get_class("search.features", "is_solr_supported")


class SearchInput(Input):
    """
    Defining a search type widget

    This is an HTML5 thing and works nicely with Safari, other browsers default
    back to using the default "text" type
    """

    input_type = "search"


# Build a dict of valid queries
VALID_FACET_QUERIES = defaultdict(list)
for facet in settings.OSCAR_SEARCH_FACETS["queries"].values():
    name = facet["field"]
    queries = [t[1] for t in facet["queries"]]
    VALID_FACET_QUERIES[name].extend(queries)


class SearchForm(FacetedSearchForm):
    """
    In Haystack, the search form is used for interpreting
    and sub-filtering the SQS.
    """

    # Use a tabindex of 1 so that users can hit tab on any page and it will
    # focus on the search widget.
    q = forms.CharField(
        required=False,
        label=_("Search"),
        widget=SearchInput(
            {"placeholder": _("Search"), "tabindex": "1", "class": "form-control"}
        ),
    )

    # Search
    RELEVANCY = "relevancy"
    TOP_RATED = "rating"
    NEWEST = "newest"
    PRICE_HIGH_TO_LOW = "price-desc"
    PRICE_LOW_TO_HIGH = "price-asc"
    TITLE_A_TO_Z = "title-asc"
    TITLE_Z_TO_A = "title-desc"

    SORT_BY_CHOICES = [
        (RELEVANCY, _("Relevancy")),
        (TOP_RATED, _("Customer rating")),
        (NEWEST, _("Newest")),
        (PRICE_HIGH_TO_LOW, _("Price high to low")),
        (PRICE_LOW_TO_HIGH, _("Price low to high")),
        (TITLE_A_TO_Z, _("Title A to Z")),
        (TITLE_Z_TO_A, _("Title Z to A")),
    ]

    # Map query params to sorting fields.  Note relevancy isn't included here
    # as we assume results are returned in relevancy order in the absence of an
    # explicit sort field being passed to the search backend.
    SORT_BY_MAP = {
        TOP_RATED: "-rating",
        NEWEST: "-date_created",
        PRICE_HIGH_TO_LOW: "-price",
        PRICE_LOW_TO_HIGH: "price",
        TITLE_A_TO_Z: "title_s",
        TITLE_Z_TO_A: "-title_s",
    }
    # Non Solr backends don't support dynamic fields so we just sort on title
    if not is_solr_supported():
        SORT_BY_MAP[TITLE_A_TO_Z] = "title_exact"
        SORT_BY_MAP[TITLE_Z_TO_A] = "-title_exact"

    sort_by = forms.ChoiceField(
        label=_("Sort by"),
        choices=SORT_BY_CHOICES,
        widget=forms.Select(),
        required=False,
    )

    @property
    def selected_multi_facets(self):
        """
        Validate and return the selected facets
        """
        # Process selected facets into a dict(field->[*values]) to handle
        # multi-faceting
        selected_multi_facets = defaultdict(list)

        for facet_kv in self.selected_facets:
            if ":" not in facet_kv:
                continue
            field_name, value = facet_kv.split(":", 1)

            # Validate query facets as they as passed unescaped to Solr
            if field_name in VALID_FACET_QUERIES:
                if value not in VALID_FACET_QUERIES[field_name]:
                    # Invalid query value
                    continue

            selected_multi_facets[field_name].append(value)

        return selected_multi_facets

    def search(self):
        # We replace the 'search' method from FacetedSearchForm, so that we can
        # handle range queries
        # Note, we call super on a parent class as the default faceted view
        # escapes everything (which doesn't work for price range queries)
        sqs = super(FacetedSearchForm, self).search()

        # We need to process each facet to ensure that the field name and the
        # value are quoted correctly and separately:
        for field, values in self.selected_multi_facets.items():
            if not values:
                continue
            if field in VALID_FACET_QUERIES:
                # Query facet - don't wrap value in speech marks and don't
                # clean value. Query values should have been validated by this
                # point and so we don't need to escape them.
                sqs = sqs.narrow("%s:(%s)" % (field, " OR ".join(values)))
            else:
                # Field facet - clean and quote the values
                clean_values = ['"%s"' % sqs.query.clean(val) for val in values]
                sqs = sqs.narrow("%s:(%s)" % (field, " OR ".join(clean_values)))

        if self.is_valid() and "sort_by" in self.cleaned_data:
            sort_field = self.SORT_BY_MAP.get(self.cleaned_data["sort_by"], None)
            if sort_field:
                sqs = sqs.order_by(sort_field)

        return sqs


class BrowseCategoryForm(SearchForm):
    """
    Variant of SearchForm that returns all products (instead of none) if no
    query is specified.
    """

    def no_query_found(self):
        """
        Return Queryset of all the results.
        """
        return self.searchqueryset


class CategoryForm(BrowseCategoryForm):
    def __init__(self, categories, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.categories = categories

    def no_query_found(self):
        """
        Return Queryset of all the results.
        """
        sqs = super().no_query_found()

        category_ids = list(self.categories.values_list("pk", flat=True))
        return sqs.filter(category__in=category_ids)

src/oscar/apps/search/__init__.py
default_app_config = "oscar.apps.search.apps.SearchConfig"

src/oscar/apps/search/views/__init__.py
from oscar.core.loading import get_class

FacetedSearchView = get_class("search.views.search", "FacetedSearchView")
CatalogueView = get_class("search.views.catalogue", "CatalogueView")
ProductCategoryView = get_class("search.views.catalogue", "ProductCategoryView")

src/oscar/apps/search/views/base.py
from django.conf import settings

from haystack.generic_views import FacetedSearchView as BaseFacetedSearchView

from oscar.core.loading import get_class

FacetMunger = get_class("search.facets", "FacetMunger")
base_sqs = get_class("search.facets", "base_sqs")


class BaseSearchView(BaseFacetedSearchView):
    facet_fields = settings.OSCAR_SEARCH_FACETS["fields"].keys()
    paginate_by = settings.OSCAR_PRODUCTS_PER_PAGE

    def get_queryset(self):
        return base_sqs()

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)

        form = context[self.form_name]

        # Show suggestion no matter what.  Haystack 2.1 only shows a suggestion
        # if there are some results, which seems a bit weird to me.
        if self.queryset.query.backend.include_spelling:
            # Note, this triggers an extra call to the search backend
            suggestion = form.get_suggestion()
            if suggestion != context["query"]:
                context["suggestion"] = suggestion

        # Convert facet data into a more useful data structure
        if "fields" in context["facets"]:
            munger = FacetMunger(
                self.request.get_full_path(),
                form.selected_multi_facets,
                self.queryset.facet_counts(),
                query_type=type(self.queryset.query),
            )
            context["facet_data"] = munger.facet_data()
            has_facets = any(
                [len(data["results"]) for data in context["facet_data"].values()]
            )
            context["has_facets"] = has_facets

        context["selected_facets"] = form.selected_facets
        context[self.page_kwarg] = context["page_obj"]

        return context

src/oscar/apps/search/views/catalogue.py
# pylint: disable=E1101
from urllib.parse import quote

from django.contrib import messages
from django.http import Http404, HttpResponsePermanentRedirect
from django.shortcuts import get_object_or_404, redirect
from django.utils.translation import gettext_lazy as _

from oscar.core.loading import get_class, get_model

BrowseCategoryForm = get_class("search.forms", "BrowseCategoryForm")
CategoryForm = get_class("search.forms", "CategoryForm")
BaseSearchView = get_class("search.views.base", "BaseSearchView")
Category = get_model("catalogue", "Category")


class CatalogueView(BaseSearchView):
    """
    Browse all products in the catalogue
    """

    form_class = BrowseCategoryForm
    context_object_name = "products"
    template_name = "oscar/catalogue/browse.html"
    enforce_paths = True

    def get(self, request, *args, **kwargs):
        try:
            return super().get(request, *args, **kwargs)
        except Http404:
            # Redirect to page one.
            messages.error(request, _("The given page number was invalid."))
            return redirect("catalogue:index")

    def get_context_data(self, *args, **kwargs):
        ctx = super().get_context_data(*args, **kwargs)
        ctx["summary"] = _("All products")
        return ctx


class ProductCategoryView(BaseSearchView):
    """
    Browse products in a given category
    """

    form_class = CategoryForm
    enforce_paths = True
    context_object_name = "products"
    template_name = "oscar/catalogue/category.html"

    def get(self, request, *args, **kwargs):
        # pylint: disable=W0201
        self.category = self.get_category()

        # Allow staff members so they can test layout etc.
        if not self.is_viewable(self.category, request):
            raise Http404()

        potential_redirect = self.redirect_if_necessary(request.path, self.category)
        if potential_redirect is not None:
            return potential_redirect

        try:
            return super().get(request, *args, **kwargs)
        except Http404:
            messages.error(request, _("The given page number was invalid."))
            return redirect(self.category.get_absolute_url())

    def is_viewable(self, category, request):
        return category.is_public or request.user.is_staff

    def redirect_if_necessary(self, current_path, category):
        if self.enforce_paths:
            # Categories are fetched by primary key to allow slug changes.
            # If the slug has changed, issue a redirect.
            expected_path = category.get_absolute_url()
            if expected_path != quote(current_path):
                return HttpResponsePermanentRedirect(expected_path)

    def get_category(self):
        return get_object_or_404(Category, pk=self.kwargs["pk"])

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["category"] = self.category
        return context

    def get_form_kwargs(self):
        kwargs = super().get_form_kwargs()
        kwargs["categories"] = self.category.get_descendants_and_self()
        return kwargs

src/oscar/apps/search/views/search.py
from django.utils.translation import gettext_lazy as _

from oscar.core.loading import get_class
from oscar.apps.search.signals import user_search

SearchForm = get_class("search.forms", "SearchForm")
BaseSearchView = get_class("search.views.base", "BaseSearchView")


class FacetedSearchView(BaseSearchView):
    form_class = SearchForm
    template_name = "oscar/search/results.html"
    context_object_name = "results"

    def dispatch(self, request, *args, **kwargs):
        # Raise a signal for other apps to hook into for analytics
        user_search.send(
            sender=self,
            session=self.request.session,
            user=self.request.user,
            query=self.request.GET.get("q", ""),
        )

        return super().dispatch(request, *args, **kwargs)

src/oscar/templates/oscar/partials/alert_messages.html
{% load string_filters %}

{% comment %}
Use message tags to control these alerts.  Available tags include:
- safe: allow HTML in the message
- block: for longer messages - this adds extra padding
- noicon: don't show an icon
- error/success/info - these change the connotation of the alert
{% endcomment %}

<div id="messages">
{% if messages %}
    {% for message in messages %}
    <div class="alert alert-dismissible {% for tag in message.tags|split %}alert-{% if tag == 'error' %}danger{% else %}{{ tag }}{% endif %} {% endfor %} fade show">
            <a class="close" data-dismiss="alert" href="#">&times;</a>
            <div class="alertinner {% if 'noicon' not in message.tags %}wicon{% endif %}">
                {% if 'noicon' not in message.tags %}
                    {# Include an icon by default #}
                    {% if 'success' in message.tags %}
                        <i class="fas fa-check-circle"></i>
                    {% elif 'info' in message.tags %}
                        <i class="fas fa-info-circle"></i>
                    {% elif 'warning' in message.tags %}
                        <i class="fas fa-exclamation-triangle"></i>
                    {% elif 'danger' in message.tags or 'error' in message.tags %}
                        <i class="fas fa-exclamation-circle"></i>
                    {% endif %}
                {% endif %}

                {# Allow HTML to be embedded in messages #}
                {% if 'safe' in message.tags %}
                    {{ message|safe }}
                {% else %}
                    {{ message }}
                {% endif %}
            </div>
        </div>
    {% endfor %}
{% endif %}
</div>

src/oscar/templates/oscar/partials/brand.html
<div class="col-sm-6 h1"><a href="{{ homepage_url }}">{% block brand_title %}{{ shop_name }}{% endblock %}</a><small> {{ shop_tagline }}</small></div>

src/oscar/templates/oscar/partials/footer.html
<footer class="container">
    {% block footer %}
        {% comment %}
            Could be used for displaying links to privacy policy, terms of service, etc.
         {% endcomment %}
    {% endblock %}
</footer>

src/oscar/templates/oscar/partials/footer_checkout.html
<footer class="container">
    {% block footer %}
    {% endblock %}
</footer>

src/oscar/templates/oscar/partials/form.html
{% load i18n %}

<form {% if form_id %}id="{{ form_id }}"{% endif %} class="{{ class }}" method="{{ method|default:"post" }}"
    {% if action %}action="{{ action }}"{% endif %}
    {% if includes_files %}enctype="multipart/form-data"{% endif %}>

    {% if not method == "get" %}{% csrf_token %}{% endif %}
    {% include 'oscar/partials/form_fields.html' %}
    <div class="form-group{% if style == 'horizontal' %} row{% endif %}">
        <div class="{% if style == 'horizontal' %}offset-sm-4 col-sm-8{% endif %}">
            <button class="btn btn-lg btn-primary" type="submit" data-loading-text="{% trans 'Saving...' %}">{% trans "Save" %}</button>
            {% trans "or" %} <a href="#" onclick="window.history.go(-1);return false" >{% trans "cancel" %}</a>.
        </div>
    </div>
</form>

src/oscar/templates/oscar/partials/form_fields.html
{% load i18n %}

{% if form.is_bound and not form.is_valid %}
    <div class="alert alert-danger">
        <strong>{% trans "Oops! We found some errors" %}</strong> - {% trans "please check the error messages below and try again" %}
    </div>
{% endif %}

{% if form.non_field_errors %}
    {% for error in form.non_field_errors %}
        <div class="alert alert-danger">
            <i class="fas fa-exclamation"></i> {{ error }}
        </div>
    {% endfor %}
{% endif %}

{% for field in form %}
    {% include 'oscar/partials/form_field.html' with field=field style=style %}
{% endfor %}

src/oscar/templates/oscar/partials/form_fields_inline.html
{% load widget_tweaks %}

<span class="error-block">{{ form.non_field_errors }}</span>
{% for field in form %}
    {% if field.is_hidden %}
        {{ field }}
    {% else %}
        <span class="form-group {% if field.errors %}error{% endif %}">
            <span class="mr-sm-1">{{ field.label_tag }}</span>
            {% render_field field class+="form-control mr-sm-2" %}
            {% for error in field.errors %}
                <ul class="error-block">
                    <li>{{ error }}</li>
                </ul>
            {% endfor %}
            {# No help text as it wraps #}
        </span>
    {% endif %}
{% endfor %}

src/oscar/templates/oscar/partials/google_analytics.html
{% if google_analytics_id %}
    <script async src="https://www.googletagmanager.com/gtag/js?id={{ google_analytics_id }}"></script>
    <script>
      window.dataLayer = window.dataLayer || [];
      function gtag(){dataLayer.push(arguments)};
      gtag('js', new Date());

      {% if user.is_authenticated %}
        gtag('config', "{{ google_analytics_id }}", { 'user_id': "{{ user.pk }}" });
      {% else %}
        gtag('config', "{{ google_analytics_id }}");
      {% endif %}
      {% block extratracking %}{% endblock %}
    </script>
{% endif %}

src/oscar/templates/oscar/partials/google_analytics_transaction.html
{% extends "oscar/partials/google_analytics.html" %}
{% load l10n %}

{% block extratracking %}
    gtag('event', 'purchase', {
      "transaction_id": '{{ order.number|escapejs }}',
      "affiliation": '{{ shop_name|escapejs }}',
      "value": '{{ order.total_incl_tax|unlocalize|escapejs }}',
      "currency": '{{ order.currency|escapejs }}',
      "tax": '{{ order.total_tax|unlocalize|escapejs }}',
      "shipping": '{{ order.shipping_incl_tax|unlocalize|escapejs }}',
      items: [
          {% for line in order.lines.all %}
          {
            'id': '{{ line.partner_sku|escapejs }}',
            'name': '{{ line.title|escapejs }}',
            'category': '{{ line.category|default:"Uncategorised"|escapejs }}',
            'price': '{{ line.unit_price_incl_tax|unlocalize|escapejs }}',
            'quantity': '{{ line.quantity|escapejs }}'
         }{% if not forloop.last %},{% endif %}
          {% endfor %}
      ]
    });
{% endblock %}

src/oscar/templates/oscar/partials/mini_basket.html
{% load currency_filters %}
{% load i18n %}

<div class="basket-mini col-sm-5 text-right d-none d-md-block">
    <strong>{% trans "Basket total:" %}</strong>
    {% if request.basket.is_tax_known %}
        {{ request.basket.total_incl_tax|currency:request.basket.currency }}
    {% else %}
        {{ request.basket.total_excl_tax|currency:request.basket.currency }}
    {% endif %}

    <div class="btn-group">
      <button type="button" class="{% block mini_basket_btn_classes %}btn btn-outline-secondary{% endblock %}" onclick="window.location.href='{% url 'basket:summary' %}';">{% trans "View basket" %}</button>
      <button type="button" class="{% block mini_basket_toggle_classes %}btn btn-outline-secondary dropdown-toggle dropdown-toggle-split{% endblock %}" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
        <span class="sr-only">Toggle Dropdown</span>
      </button>
      <div class="{% block mini_basket_dropdown_classes %}dropdown-menu dropdown-menu-right{% endblock %}">
        {% include "oscar/basket/partials/basket_quick.html" %}
      </div>
    </div>
</div>

src/oscar/templates/oscar/partials/nav_checkout.html
<div class="navbar primary">
    {% load flatpages %}
    {% get_flatpages '/order/' as flatpages %}
    {% if flatpages %}
        <div class="navbar-inner">
            <div class="container" style="width: auto;">
                <a class="btn navbar-btn" data-toggle="collapse" data-target=".navbar-collapse">
                    <i class="fas fa-bars"></i>
                </a>
                <a class="brand hidden" href="{{ homepage_url }}">{{ shop_name }}</a>
                <div class="navbar-collapse">

                    <ul class="nav">
                        <!-- Links to modal flatpages -->
                        {% for page in flatpages %}
                            <li>
                                <a data-toggle="modal" href="#{{ page.title|slugify }}">{{ page.title }}</a>
                            </li>
                        {% endfor %}
                        <!-- Delete this if other links present -->
                        <li><a href="{{ homepage_url }}">&larr;</a></li>
                    </ul>
                </div><!-- /.navbar-collapse -->
            </div>
        </div><!-- /navbar-inner -->
    {% endif %}
</div><!-- /navbar -->

src/oscar/templates/oscar/partials/nav_primary.html
{% load currency_filters %}
{% load category_tags %}
{% load i18n %}

<nav class="{% block nav_classes %}navbar navbar-expand-lg navbar-dark bg-dark{% endblock %}">
    {% block navbar_toggler %}
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
    {% endblock %}

    {% block navbar_basket %}
        <a class="btn btn-secondary float-right btn-cart ml-auto d-inline-block d-md-none" href="{% url 'basket:summary' %}">
            <i class="fas fa-shopping-cart"></i>
            {% trans "Basket" %}
            {% if not request.basket.is_empty %}
                {% if request.basket.is_tax_known %}
                    {% blocktrans with total=request.basket.total_incl_tax|currency:request.basket.currency %}
                        Total: {{ total }}
                    {% endblocktrans %}
                {% else %}
                    {% blocktrans with total=request.basket.total_excl_tax|currency:request.basket.currency %}
                        Total: {{ total }}
                    {% endblocktrans %}
                {% endif %}
            {% endif %}
        </a>
    {% endblock %}

    {% block navbar_collapse %}
        <div class="collapse navbar-collapse" id="navbarSupportedContent">
            {% block nav %}
                <ul class="navbar-nav mr-auto">
                    {% block nav_items %}
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                {% block browse_store_text %}{% trans "Browse store" %}{% endblock %}
                            </a>
                            <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                                {% category_tree depth=1 as tree_categories %}
                                <a class="dropdown-item" href="{% url 'catalogue:index' %}">{% trans "All products" %}</a>
                                {% if tree_categories %}
                                    <div class="dropdown-divider"></div>
                                    {% for tree_category in tree_categories %}
                                        <a class="dropdown-item" href="{{ tree_category.get_absolute_url }}">{{ tree_category.name }}</a>
                                    {% endfor %}
                                {% endif %}
                                <div class="dropdown-divider"></div>
                                {% block nav_dropdown_extra_items %}
                                    <a class="dropdown-item" href="{% url 'offer:list' %}">{% trans "Offers" %}</a>
                                {% endblock %}
                            </div>
                        </li>
                   {% endblock %}
               </ul>
            {% endblock %}

            {% block nav_extra %}
                {% include "oscar/partials/search.html" %}
            {% endblock %}
        </div>
    {% endblock %}
</nav>

src/oscar/templates/oscar/partials/pagination.html
{% load display_tags %}
{% load i18n %}

{% if paginator.num_pages > 1 %}
    <nav>
        <ul class="pagination justify-content-center">
            {% if page_obj.has_previous %}
                <li class="page-item">
                    <a class="page-link" href="?{% get_parameters 'page' %}page={{ page_obj.previous_page_number }}" tabindex="-1">
                        {% trans "previous" %}
                    </a>
                </li>
            {% endif %}
            <li class="page-item disabled">
                <span class="page-link">
                    {% blocktrans with page_num=page_obj.number total_pages=paginator.num_pages %}
                        Page {{ page_num }} of {{ total_pages }}
                    {% endblocktrans %}
                </span>
            </li>
            {% if page_obj.has_next %}
                <li class="page-item">
                    <a class="page-link" href="?{% get_parameters 'page' %}page={{ page_obj.next_page_number }}">
                        {% trans "next" %}
                    </a>
                </li>
            {% endif %}
        </ul>
    </nav>
{% endif %}

src/oscar/templates/oscar/partials/search.html
{% load i18n %}

<form class="form-inline my-2 my-lg-0" method="GET" action="{% url 'search:search' %}">
    <input class="form-control mr-sm-2" name="q" id="id_q" placeholder="{% trans 'Search' %}" aria-label="{% trans 'Search' %}">
    <button class="btn btn btn-secondary my-2 my-sm-0" type="submit">{% trans "Search" %}</button>
</form>